; -----------------------------------------------------------;
;		   4		     ;	
;			 		     ; 	
; :                                            ;
; 	    TMS320Cxx DSP Applications Engineer              ;
;           Texas Instruments                                ;
; -----------------------------------------------------------;
ONEPASS   .set 0			; 1=no avg 0= 
YES 	  .set 1			;
NO 	  .set 0			;
; -----------------------------------------------------------;
BITLEN2  	.set 54h		; 0078h	;   CMD
BITLEN 		.set 0a8h		; 079h	;   XMIT
SENDC 		.set 08f0h
; ===============================
     .ds 0x60			; AIC/FFT      B2
; ==================================================================
;    
; -----------------------------
;  ,     AIC    
;       '0'  '1'.
;  .if/.endif   TA  TB.
;
;   -
; --------------------
; 	Fclk = 10 MHz 		   
;       Fbit = Fclk/4 		    
;
;   (  -    )
;     Fscf = Fclk/(2*TA) 	    
;     Fs   = Fclk/(2*TA*TB)          
;
;   ( )
;     Fscf = Fclk/(2*RA) 	    
;     Fs   = Fclk/(2*RA*RB)         
;
;  
;     Fscf = Fclk/(2*TA) 	    
;     Fs   = Fclk/(2*TA*TB)         
;
; : 1)  TA/TB    / (SNR) /
;           2) TA/RA     (SCF)
;           3) TA   BW  
;
;
;     /  TA/RA
; ,       (  ).
;         , 
;  ,     .
;
; TA/RA  SCF 		Fadc/Fdac ( )
;   1    5000.000    60.764   
;   2    2500.000    30.382   
;   3    1666.667    20.255   ,  
;   4    1250.000    15.191  ,  
;   5    1000.000    12.153  , 
;   6    833.333     10.127   
;   7    714.286     8.681      Fs
;   8    625.000     7.595 OK
;   9    555.556     6.752 OK
;  10    500.000     6.076 OK
;  11    454.545     5.524 OK
;  12    416.667     5.064 OK
;  13    384.615     4.674 OK
;  14    357.143     4.340 OK
;  15    333.333     4.051 OK
;  16    312.500     3.798 OK
;  17    294.118     3.574 OK
;  18    277.778     3.376 OK
;  19    263.158     3.198 OK
;  20    250.000     3.038 OK
;  21    238.095     2.894 OK
;  22    227.273     2.762 OK
;  23    217.391     2.642 OK
;  24    208.333     2.532 OK
;  25    200.000     2.431 OK
;  26    192.308     2.337 OK
;  27    185.185     2.251 OK
;  28    178.571     2.170 OK
;  29    172.414     2.095 OK
;  30    166.667     2.025 OK
;  31    161.290     1.960 OK
; =======================================================;
;       			 ;
;						         ;
; Fselect 	                	 TA/TB  ;
; =======================================================;
_2560	.set 0		; 31/63 80 dB SNR  /

_5000a	.set 0		; 25/40 80 dB SNR
_5000b	.set 0		; 22/45 80 dB SNR
_5000c	.set 0		; 20/50 80 dB SNR
_5000d	.set 0		; 18/56 80 dB SNR
_5000e	.set 0		; 16/63 80 dB SNR

_10000a	.set 1		; 12/42 80 dB SNR
_10000b	.set 0		; 11/45 80 dB SNR
_10000c	.set 0		; 10/50 80 dB SNR
_10000d	.set 0		; 9/56 80 dB SNR
_10000e	.set 0		; 8/63 80 dB SNR

_20000a	.set 0		; 8/31 78 dB SNR
_20000b	.set 0		; 7/36 72 dB SNR
_20000c	.set 0		; 6/42 70 dB SNR
_20000d	.set 0		; 5/50 67 dB SNR
_20000e	.set 0		; 4/63 62 dB SNR

_38000a	.set 0		; 9/15 80 dB SNR
_38000b	.set 0		; 8/16 78 dB SNR
_38000c	.set 0		; 7/19 78 dB SNR
_38000d	.set 0		; 6/22 72 dB SNR

_44000a	.set 0		; 9/13 78 dB SNR
_44000b	.set 0		; 8/14 80 dB SNR
_44000c	.set 0		; 7/16 75 dB SNR
_44000d	.set 0		; 6/19 70 dB SNR
_44000e	.set 0		; 5/23 68 dB SNR
_44000f	.set 0		; 4/28 65 dB SNR
_44000g	.set 0		; 3/38 50 dB SNR

_48000a	.set 0		; 10/10  , 70 dB SNR ( Vpp)
_48000b	.set 0		; 9/12 80 dB SNR
_48000c	.set 0		; 8/13 80 dB SNR
_48000d	.set 0		; 7/15 75 dB SNR
_48000e	.set 0		; 6/17 72 dB SNR
_48000f	.set 0		; 5/22 70 dB SNR
_48000g	.set 0		; 4/26 60 dB SNR
_48000h	.set 0		; 3/35  , 50 dB SNR ( Vpp)

_78000a	.set 0		; 8/ 8  
_78000b	.set 0		; 7/ 9  
_78000c	.set 0		; 6/11 
_78000d	.set 0		; 5/13 62 dB SNR
_78000e	.set 0		; 4/16 60 dB SNR
_78000f	.set 0		; 3/21  , 45 dB SNR
_78000g	.set 0		; 2/32   -  

_100000a	.set 0		; 6/ 8  
_100000b 	.set 0		; 5/10  , 45 dB SNR
_100000c 	.set 0		; 4/12 60
_100000d 	.set 0		; 3/16 50
_100000e 	.set 0		; 2/24  

_125000a 	.set 0		; 4/10  , dB SNR
_125000b 	.set 0		; 3/13  , dB SNR
_125000c 	.set 0		; 2/20   -  
; =======================================================;
;    TA/TB (RA/RB)  		 ;
; =======================================================;
     .if _2560	 			; Fs=2.560  ()
TA 		.word 31		;
TB 		.word 63		;
     .endif				;
;*******************************
     .if _5000a				; Fs=5.000 
TA 		.word 25		;
TB 		.word 40		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _5000b				; Fs=5.051 
TA 		.word 22		;
TB 		.word 45		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _5000c				; Fs=5.000 
TA 		.word 20		;
TB 		.word 50		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _5000d				; Fs=4.960 
TA 		.word 18		;
TB 		.word 56		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _5000e				; Fs=4.960 
TA 		.word 16		;
TB 		.word 63		;
     .endif				;
;*******************************
     .if _10000a			; Fs=9.921 
TA 		.word 12		;
TB 		.word 42		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _10000b			; Fs=10.101 
TA 		.word 11		;
TB 		.word 45		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _10000c			; Fs=10.000 
TA 		.word 10		;
TB 		.word 50		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _10000d			; Fs=9.921 
TA 		.word 9			;
TB 		.word 56		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _10000e			; Fs=9.921 
TA 		.word 8			;
TB 		.word 63		;
     .endif				;
; *******************************
     .if _20000a			; Fs=20.161 
TA 		.word 8			;
TB 		.word 31		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _20000b			; Fs=19.841 
TA 		.word 7			;
TB 		.word 36		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _20000c			; Fs=19.841 
TA 		.word 6			;
TB 		.word 42		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _20000d			; Fs=20.000 
TA 		.word 5			;
TB 		.word 50		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _20000e			; Fs=19.841 
TA 		.word 4			;
TB 		.word 63		;
     .endif				;
; *******************************
     .if _38000a			; Fs=37.037 
TA 		.word 9			;
TB 		.word 15		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _38000b			; Fs=39.063 
TA 		.word 8			;
TB 		.word 16		;
     .endif				;	
; - - - - - - - - - - - - - - - -
     .if _38000c			; Fs=37.593 
TA 		.word 7			;
TB 		.word 19		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _38000d			; Fs=37.879 
TA 		.word 6			;
TB 		.word 22		;
     .endif				;
; *******************************
     .if _44000a			; Fs=42.735 
TA 		.word 9			;
TB 		.word 13		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _44000b			; Fs=44.643 
TA 		.word 8			;
TB 		.word 14		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _44000c			; Fs=44.643 
TA 		.word 7			;
TB 		.word 16		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _44000d			; Fs=43.860 
TA 		.word 6			;
TB 		.word 19		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _44000e			; Fs=43.478 
TA 		.word 5			;
TB 		.word 23		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _44000f			; Fs=44.643 
TA 		.word 4			;
TB 		.word 28		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _44000g			; Fs=43.860 
TA 		.word 3			;
TB 		.word 38		;
     .endif				;
; *******************************
     .if _48000a			; Fs=50.000 
TA		.word 10		;
TB 		.word 10		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _48000b			; Fs=46.296 
TA 		.word 9			;
TB 		.word 12		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _48000c			; Fs=48.077 
TA 		.word 8			;
TB 		.word 13		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _48000d			; Fs=47.619 
TA 		.word 7			;
TB 		.word 15		;
     .endif				;	
; - - - - - - - - - - - - - - - -
     .if _48000e			; Fs=49.019 
TA 		.word 6			;
TB 		.word 17		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _48000f			; Fs=45.455 
TA 		.word 5			;
TB 		.word 22		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _48000g			; Fs=48.077 
TA 		.word 4			;
TB 		.word 26		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _48000h			; Fs=47.619 
TA 		.word 3			;
TB 		.word 35		;
     .endif				;
; *******************************
     .if _78000a			; Fs=78.125 
TA 		.word 8			;  
TB 		.word 8			;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _78000b			; Fs=79.365 
TA 		.word 7			;  
TB 		.word 9			;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _78000c			; Fs=75.758 
TA 		.word 6			; 
TB 		.word 11		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _78000d			; Fs=76.923 
TA 		.word 5			; 62 dB SNR
TB 		.word 13		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _78000e			; Fs=78.125 
TA 		.word 4			; 65 dB SNR
TB 		.word 16		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _78000f			; Fs=79.365 
TA 		.word 3			;   
TB 		.word 21		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _78000g			; Fs=78.125 
TA 		.word 2			;   -  
TB 		.word 32		;
     .endif				;
; *******************************
     .if _100000a			; 104 
TA 		.word 6			;   -   
TB 		.word 8			;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _100000b			; 100   .
TA 		.word 5			; Fdisp = Fin(1+Fnyq)/2
TB 		.word 10		;   0-50 
     .endif				;   50-0 ,   
; - - - - - - - - - - - - - - - -
     .if _100000c			; 104 
TA 		.word 4		        ; 60 dB SNR - ,   OK 
TB 		.word 12		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _100000d			; 104 
TA 		.word 3		        ; 50 dB SNR - ,   OK 
TB 		.word 16		;
     .endif				;
; - - - - - - - - - - - - - - - -
     .if _100000e			; 104 
TA 		.word 2		        ;  
TB 		.word 24		;
     .endif				;
; *******************************
     .if _125000a			; 125  -  SNR,  
TA 		.word 4		        ; Fdisp = Fin (1+Fnyq) /2
TB 		.word 10		;   0-64 
     .endif				;   64-0 ,   
; - - - - - - - - - - - - - - - -
     .if _125000b			; 128 
TA 		.word 3		        ; Fdisp = Fin(1+Fnyq) /2
TB 		.word 13		;   0-64 
     .endif				;   64-0 ,   
; - - - - - - - - - - - - - - - -
     .if _125000c			; 125 
TA 		.word 2		        ;   -  
TB 		.word 20		;
     .endif				;
; *******************************
AIC_CMD 	.word 0x0003	; 0x72 0000 0000 0000 0011=0x0003
SIG_DEL 	.word 0x0000	; 0x73
STAT1 		.word 0x0000	; 0x74
ACCU_lo 	.word 0x0000	; 0x75
ACCU_hi 	.word 0x0000	; 0x76
REAL 		.word 0x0000	; 0x77
IMAG 		.word 0x0000	; 0x78
AUX0 		.word 0x0000	; 0x79
AUX1 		.word 0x0000	; 0x7A
FFT_S 		.word 256	;
FFT_S-1 	.word 255	;
FFT_S/2 	.word 128	;
FFT_S/2-1 	.word 127	;
scratch 	.word 0
; ----------------------------------------------------------------
;   ,   B0   
; ----------------------------------------------------------------
        .mmregs			;
        .ps 080ah		;
        B RINT			;RINT ,    
        B XINT			;XINT XINT -   ,   
                                ;
; ----------------------------------------------------------------
;  ,    DSKD 
; ----------------------------------------------------------------
        .ps 	0x0a00		;
        .entry			;
start:				;
        SETC 	INTM
        SETC 	SXM
        SETC 	OVM		;   
        LDP 	#0		;    MMR  B2
        SPLK 	#0830h,PMST
        LACC 	#0
        SAMM 	CWSR		;      
        SAMM 	PDWSR		;   
        SPLK 	#020h,IMR	;  XINT   TX  RX
                                ;   AIC   
AIC_RS  SPLK 	#01h,PRD	;  10  Tout
        SPLK 	#20h,TCR	;    AIC
        MAR 	*,AR0
        LACC 	#0008h		;     
        SACL 	SPC		; FSX  
        LACC 	#00c8h		; 16  
        SACL 	SPC
        LACC 	#080h		;
        SACH 	DXR
        SACL 	GREG
        LAR 	AR0,#0FFFFh	;  AIC  BR\pin
        RPT 	#500		;      500 
        LACC 	*,0,AR0		; (.25ms  50ns)
        SACH 	GREG
        SETC 	SXM		;
; -------------------------------
        LACC 	AIC_CMD		;  AIC
        CALL 	AIC_2nd		;  
       ; ------------------------
        LACC 	TB,2		;  AIC B 
        ADD 	TB,9		;
        ADD 	#2		;
        CALL 	AIC_2nd		;  
       ; -----------------------
        LACC 	TA,2		;  AIC A regs
        ADD 	TA,9		;
        CALL 	AIC_2nd		;  
       ; -----------------------
        LDP 	#0
        LACC 	#010h		;   RINT AIC
        SACL 	IMR		;  INT0  EOC ( Conv)
; ************************************************************************
MAIN:   CALL	Init_S		;  512   
        LAR 	AR0, FFT_S	;  
        CALL 	FFT		;

      .if ONEPASS
        CALL 	TO_HOST		;
        B 		MAIN
       ; -----------------------
      .else
        CALL 	Init_D		;
        LAR 	AR0,FFT_S	;  
         	FFT		;
      .endif
; ************************************************************************
AVG2:   LAR 	AR5, #_B_base
        LAR 	AR6, #_D_base
        LAR 	AR7, #255
        MAR 	*,AR5
AVGX:   LACC 	*+,0,AR6
        ADD 	*
        SFR
        SACL 	*+
        MAR 	*+,AR7
        BANZ 	AVGX,*-,AR5
        CALL 	TO_HOST		;
       ; -----------------------
        B 	MAIN		;

; ************************************************************************
Init_S: LAR 	AR6,#_D_base	; _D_base = A1[n],A2[n],A1[n+1],A2[n+1],...
        LAR 	AR7,#511		;
        MAR 	*,AR7			;   
        CLRC 	INTM			;     512 
FILL 	BANZ 	FILL,*,AR7		;
        SETC 	INTM			;
        LAR 	AR5,# _B_base	;
        LAR 	AR6,# _D_base	;
        LAR 	AR7,#255		;
        MAR 	*,AR6			;
FILLX   LACC 	*+,0,AR5		;   256   
        SACL 	*+,0,AR7		;
        BANZ 	FILLX,*-,AR6	;
       ; -----------------------
        LAR 	AR7,#255	;
        LAR 	AR5,#_D_base	;
        MAR 	*,AR6		;
FILLY   LACC 	*+,16,AR5		;    256    
        SACH 	*+			; REAL=X[n]
        SACL 	*+,0,AR7		; IMAG=0
        BANZ 	FILLY,*-,AR6		;
        RET				;
; ************************************************************************
Init_D: LAR 	AR6,#_D_base	;
        LAR 	AR5,#_B_base	; ()     
        LAR 	AR7,#255		;
        MAR 	*,AR5			;
FILLD   LACL 	*,AR6			;  x[n+256]
        LAR 	AR0,*			;  X[n]
        SACL 	*+			; REAL=X[n]
        SACH 	*+,0,AR5		; IMAG=0
        SAR 	AR0,*+,AR7		;  X[n]   
        BANZ 	FILLD,*-,AR5	;
        RET					;
*************************************************************************
TO_HOST LACC 	#80h
        CALL 	BCXMIT		;    (START)
        CALL 	BRECV		;  (host)  (01Bh)
        SUB 	#01Bh
        NOP			;  NOP    
        NOP			;      BCND
        BCND 	TO_HOST,NEQ
        LAR 	AR3,#_D_base	; AR3 =   
        LAR 	AR5,FFT_S/2-1	; AR5 =  
        MAR 	*,AR3		;
more2   LACC 	*+		;       (host)
        MAR 	*+		;   
        RPT 	#7		;
        SFR			;
        CALL 	XMIT		;
        MAR 	*,AR5		;
        BANZ 	more2,*-,AR3	;
        RET
; ***********************************************************************
FFT:    MAR 	*,AR0			;     AR0 = 
        SAR 	AR0,FFT_S		;
        MAR 	*-			;
        SAR 	AR0,FFT_S-1		;
        MAR 	*+			;
        MAR 	*BR0+			; AR0 = AR0 > > 1;
        SAR 	AR0,FFT_S/2		;
        MAR 	*-
        SAR 	AR0,FFT_S/2-1		;
       ; -----------------------
        LAR 	AR0,FFT_S/2		;
New_stg LAR 	AR1,#_D_base		; AR1 -   BFLY 
        LAR 	AR2,#_D_base		; AR2 -   BFLY
        LAR 	AR3,#_T_base+1		; AR3 -  
        LAR 	AR4,FFT_S/2		; AR4   
        B 		n_DFT2,*,AR1	;
DFT:    MAR 	*BR0+,AR5		;      
        LAR 	AR5,#1			;     *BR0+/BANZ
        MAR 	*BR0+,AR1		;  1  *BR0+   !
       ; ----------------------------------------
       ; AR1=   AR2=   AR3= 
       ; ----------------------------------------
BFLY:   LACC 	*,14,AR2		; (imag1+imag2)/4
        ADD 	*,14,AR1		;
        SACH 	*+,1,AR2		;    imag
        SUB 	*,15			; (imag1-imag2)/2
        SACH 	*+,1,AR1		;    imag
        LACC 	*,14,AR2		; (real1+real2)/4
        ADD 	*,14,AR1		;
        SACH 	*+,1,AR2		;    real
        SUB 	*,15			; (real1-real2)/2
        SACH 	*,1,AR5			;    real
        BANZ 	OK,*BR0+,AR3		;      
       ; -----------------------
        MAR 	*+,AR2		;   TW( )(xxx0000+1)
        MAR 	*+		;      
        MAR 	*0+		;
        MAR 	*0+,AR1		;
n_DFT2: MAR 	*0+		;    
        MAR 	*0+,AR4		;
        BANZ 	DFT,*0-,AR3	;   ,  AR4  
        MAR 	*,AR0			;
        MAR 	*BR0+			;
        BANZ 	new_stg,*		;    1,  
        B 	endFFT		;
       ; -----------------------
OK 	LT 	*-,AR2			; TREG=TWR **  -Q15
        MPY 	*-			; PREG=REAL*TWR
        LTP 	*+,AR3			; TREG=IMAG  ACCU=REAL*TWR
        MPY 	*			; PREG=IMAG*TWI AR2=R AR3=I
        LTS 	*+,AR2			; TREG=TWI ACCU=REAL*TWR-IMAG*TWI
        MPY 	*			; PREG=REAL*TWI
        SACH 	*-,1,AR2	;<<;
        LTP 	*,AR3			; TREG=IMAG ACCU=REAL*TWI
        MPY 	*BR0+,AR2		; PREG=IMAG*TWR
        APAC				; ACCU=IMAG*TWR+REAL*TWI
        SACH 	*+,1,AR2	;<<;
        B 	BFLY,*+,AR1		;
       ; ------------------------------------------------------------
endFFT: MAR 	*,AR2			;  REAL  IMAG   
        LAR 	AR2,#_D_base		; AR3=  
        LAR 	AR3,FFT_S-1		; AR5=  
        LAR 	AR0,FFT_S
       ; -----------------------------------------------------------;
       ; :   ,   cos!           ;
       ;          ;
       ;     .                         ;
       ; -----------------------------------------------------------;
      ; mar 	*BR0+			;      (DC)
more_MAG
        MAR 	*BR0-			; -IMAG [-1]  1-COS (nwt/N)  + 1
        LACC 	*BR0+,15		;  IMAG [-0]      |
        SUB 	*BR0+,16		; +IMAG [+1]       <-+++->
        ADD 	*BR0-,15		;  IMAG 		   + + -.5
        SACH 	IMAG			;
        MAR 	*+			;  REAL
        MAR 	*BR0-			; -REAL [-1]
        LACC 	*BR0+,15		;  REAL[-0]  X[-1] -2*X[0] + X[1]
        SUB 	*BR0+,16		; +REAL [+1]
        ADD 	*BR0-,15,AR1	        ;  REAL
        SACH 	REAL			;
        SQRA   IMAG		        ; IMAG  REAL     0x7fff Q15
        LTP    REAL			;       
        MPY    REAL			;
        APAC				;  -  Q30
        ADD    #0x1			;  floor ; log(0)  !
        LAR    AR1,#17			; -   Y 
        RPT    #31			;
        NORM   *-			;
        NOP
        NOP
        MAR      *,AR2			;
        MAR      *BR0-			; -REAL; () log(f)    REAL( )( )
        SACH     *,2			;   1.0     
        LACL     *			;   ACCU_lo
        SAR      AR1,*			;    (AR1)
        ADD      *,16			;
        RPT      #10			;    ACCU_hi
        SFL				;  ,  ADDH,   
    ;   sach     *			;
    ;   addh     *			;
        SACH     *			;
        LACC     *			;
        AND      #0xfffc,0		;
        SACL     *BR0+			;  REAL
        MAR      *-			;  IMAG
        MAR      *BR0+,AR3		; +IMAG
        BANZ     more_MAG,*-,AR2	;     
       ; --------------------------------------- -----------------
BITREV: LAR 	AR0,FFT_S		;    
        LAR 	AR1,*_D_base		;   , 
        LAR 	AR2,*_D_base+1		;    REAL  IMAG
        LAR 	AR3,FFT_S-1		;   
more_BR LACC 	*+			;  
        MAR 	*+,AR1			;
        SACL 	*BR0+,0,AR3		;      IMAG
        BANZ 	more_BR,*-,AR2		;    ,  ?
       ; -----------------------
        RET				;  !!
******************************************************************
AIC_2nd SACH 	DXR
        CLRC 	INTM
        IDLE
        ADD 	#6,15			;  ACCU_hi = 3   XMIT
        SACH 	DXR				;
        IDLE				; ACCU_hi  2- XMIT
        SACL 	DXR				;
        IDLE				; ACCU_lo  
        SACL 	DXR,2			;     LSB = 00
        IDLE
        RET				;
*******************************************************************
;  
*******************************************************************
; ============================================================================
;   
; ============================================================================
xmtwrd  SACL 	stratch
        RPT 	#7
        SFR
        CALL 	XMIT		;   
        LACC 	stratch		;
BCXMIT  BCND    $+4,bio		;   (0)  PC
        B 	$-2
; --------------------------------------- --------------------------------------
; xmtbyte follows now	      ;   ,     pgm
;
; 'Xmtbyte'  ARP->AR0   ACCU ='   '
;  -(0) +   + - (2)
; --------------------------------------- --------------------------------------
XMIT 	  CLRC 	c		; -=0
          LAR 	ar1,#8		; : 1 - + 8   (+ 2 )
nextbit1  BCND 	snd0,nc		;  c=1  1,   0
snd1 	  SETC 	xf		;  
          B 	snd
snd0 	  CLRC 	xf
snd 	  RPT 	#BITLEN		;   
          MAR 	*,ar1
          ROR			; lsb (accu) - >  
          BANZ 	nextbit1,*-	;     (10 )
          SETC 	xf
          RPT 	#BITLEN
          NOP
          RPT	#BITLEN
          NOP
          RET
; ============================================================================
;  
; ============================================================================
BRECV:
wait 	BCNDD 	STOK,bio	;  -
        LAR 	AR1,#7
        LACL 	#0
        B 	wait		;
STOK    RPT 	#BITLEN2	; BITLEN  
        NOP
        MAR 	*,AR1		;   - 1
WTBIT   SFR
        RPT 	#BITLEN		;   8/3 
        NOP			; BITLEN/2 
        BCND 	ZEROBT,bio
        ADD 	#80h
ZEROBT  BANZ 	WTBIT,*-	;  ?
        RET			; ACC =  

****************************************************************************
****************************************************************************
****************************************************************************
; ******************************************************************
;  :       !
; ************************************************************************
RINT:   SST 	#1,STAT1		;  ARP  ARB LST1
        MAR 	*,AR7			;
        BANZ 	more_buf,*-,AR6		;   - ,  w/o EINT
        LAR 	AR7,#0			;
        LST 	#1,STAT1		;
        RET				;
more_buf				;
        LACC 	DRR			;
        SACL 	*+			;<<< Ax[n],   
       ; -----------------------
FASTRET LST 	#1,STAT1		;
        RETE				;
XINT:   RETE
; ====================================================================
        .listoff			;
        .ds 01000h			;  :    
        .include "dsk_twid.asm"		; 0x400 (B2)  CONF 1
        .liston
        .end
